Bug 704088 - Review Request: gcal - GNU Gregorian calendar program
Summary: Review Request: gcal - GNU Gregorian calendar program
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Hushan Jia
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-05-12 06:46 UTC by Daiki Ueno
Modified: 2011-05-27 20:24 UTC (History)
5 users (show)

Fixed In Version: gcal-3.6-3.fc14
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-05-19 01:42:55 UTC
hjia: fedora-review+
tibbs: fedora-cvs+


Attachments (Terms of Use)

Description Daiki Ueno 2011-05-12 06:46:09 UTC
Spec URL: http://ueno.fedorapeople.org/gcal/gcal.spec
SRPM URL: http://ueno.fedorapeople.org/gcal/gcal-3.6-1.fc15.src.rpm
Description:
Gcal is a program for calculating and printing calendars.  Gcal
displays hybrid and proleptic Julian and Gregorian calendar sheets,
respectively.  It also displays holiday lists for many countries
around the globe.

Comment 1 Theodore Lee 2011-05-15 12:40:16 UTC
I'm not a sponsored packager yet, so I'll just be doing an informal review of this package.

MUST Items
==========

OK - rpmlint must be run on all rpms

$ rpmlint gcal-3.6-1.fc15.src.rpm
gcal.src: W: spelling-error %description -l en_US proleptic -> epileptic
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
$ rpmlint gcal-3.6-1.fc15.x86_64.rpm gcal-debuginfo-3.6-1.fc15.x86_64.rpm
gcal.x86_64: W: spelling-error %description -l en_US proleptic -> epileptic
gcal.x86_64: W: no-manual-page-for-binary gcal
gcal.x86_64: W: no-manual-page-for-binary txt2gcal
gcal.x86_64: W: no-manual-page-for-binary tcal
gcal.x86_64: W: no-manual-page-for-binary gcal2txt
2 packages and 0 specfiles checked; 0 errors, 5 warnings.

After installation:
$ rpmlint gcal
gcal.x86_64: W: spelling-error %description -l en_US proleptic -> epileptic
gcal.x86_64: W: no-manual-page-for-binary gcal
gcal.x86_64: W: no-manual-page-for-binary txt2gcal
gcal.x86_64: W: no-manual-page-for-binary tcal
gcal.x86_64: W: no-manual-page-for-binary gcal2txt
1 packages and 0 specfiles checked; 0 errors, 5 warnings.

OK - Package must meet naming guidelines
OK - Spec file name must match base package name
OK - Package must meet packaging guidelines
OK - Package must meet licensing guidelines
OK - License tag must match actual license
OK - Any license files must be in %doc
OK - Spec file must be in American English
OK - Spec file must be legible

OK - Sources must match upstream

$ sha1sum gcal-3.6.tar.xz gcal-3.6-upstream.tar.xz
de58da0a15b73e377661212d65b9f82446ae7f11  gcal-3.6.tar.xz
de58da0a15b73e377661212d65b9f82446ae7f11  gcal-3.6-upstream.tar.xz

OK - Package must build on at least one primary arch

Builds on x86_64 with mock.

N/A - Arches that the package doesn't build on must be excluded with a relevant bug
OK - All necessary build dependencies must be in BuildRequires
OK - Locales must be handled properly
N/A - Binary rpms containing libraries must call ldconfig
OK - Package must not bundle system libraries
N/A - Relocatable packages must have rationalization.
OK - Package must own all directories it creates
OK - Package must not list a file more than once in %files
OK - Files must have correct permissions
OK - Macros must be consistent
OK - Package must contain code or permissible content
N/A - Large documentation files must be in a -doc subpackage
OK - %doc files must not affect program operation
N/A - Header files must be in a -devel subpackage
N/A - Static libraries must be in a -static package
N/A - Library files that end in .so must go in a -devel package
N/A - -devel packages must require the base package using a fully versioned dependency
OK - Package must NOT contain any .la libtool archives
N/A - Packages containing GUI applications must include a %{name}.desktop file
OK - Packages must not own files or directories already owned by other packages
OK - All filenames in rpm packages must be valid UTF-8

SHOULD Items
============

N/A - If the package is missing license text in a separate file, the packager should query upstream for it
N/A - Description and summary should contain translations if available
OK - Package should build in mock

OK - Package should build on all supported architectures

Scratch build seems okay:
http://koji.fedoraproject.org/koji/taskinfo?taskID=3072653

OK - Package should function as described.

Basic testing of the gcal command doesn't seem to have turned up any issues.

OK - Scriptlets should be sane
N/A - Non-devel subpackages should require the base package with a full version
N/A - pkgconfig files should be placed appropriately
N/A - File dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin should require package instead
! - Binaries/scripts should have man pages

Issues
======

The binaries in the package are missing man pages, although they have quite comprehensive info documentation. Perhaps upstream could be asked to convert some of the docs?

$ rpmls gcal-3.6-1.fc15.x86_64.rpm
[...]
-rw-r--r--  /usr/share/gcal/CREDITS
-rw-r--r--  /usr/share/gcal/Makefile.in
-rw-r--r--  /usr/share/gcal/README
[...]

It seems a bit odd that these files are installed under /usr/share - are they needed, or can they just be excluded?

I don't think any of these issues are blocking though, so were I a sponsored packager, I would declare this package APPROVED.

Comment 2 Daiki Ueno 2011-05-17 01:27:41 UTC
(In reply to comment #1)

Thank you for the review.

> The binaries in the package are missing man pages, although they have quite
> comprehensive info documentation. Perhaps upstream could be asked to convert
> some of the docs?

The man pages are available in the upstream git repository but not in the tarballs.  So I included them in the new SRPM.

> $ rpmls gcal-3.6-1.fc15.x86_64.rpm
> [...]
> -rw-r--r--  /usr/share/gcal/CREDITS
> -rw-r--r--  /usr/share/gcal/Makefile.in
> -rw-r--r--  /usr/share/gcal/README
> [...]
> 
> It seems a bit odd that these files are installed under /usr/share - are they
> needed, or can they just be excluded?

Hmm, at least Makefile.in is useless - removed.

> I don't think any of these issues are blocking though, so were I a sponsored
> packager, I would declare this package APPROVED.

Thanks, I'll ask someone to do the formal review - based on your comprehensive review, it should be quick.

Spec URL: http://ueno.fedorapeople.org/gcal/gcal.spec
SRPM URL: http://ueno.fedorapeople.org/gcal/gcal-3.6-2.fc15.src.rpm

Comment 3 Hushan Jia 2011-05-17 08:10:06 UTC
Review result:
[x] - OK, [-] - needs fix

[-] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces.
I think its better to add a group to the spec file.

[x] MUST: The package must be named according to the Package Naming Guidelines .

[x] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec

[-] MUST: The package must meet the Packaging Guidelines
Please use optflags when building: http://fedoraproject.org/wiki/Packaging/Guidelines#Compiler_flags

[x] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .

[x] MUST: The License field in the package spec file must match the actual license.

[x] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]

[x] MUST: The spec file must be written in American English.

[x] MUST: The spec file for the package MUST be legible.

[x] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

[x] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.

[x] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.

[x] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

[x] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[N/A] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.

[x] MUST: Packages must NOT bundle copies of system libraries.

[N/A] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.

[x] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

[x] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)

[x] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.

[x] MUST: Each package must consistently use macros.

[x] MUST: The package must contain code, or permissable content.

[x] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).

[x] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.

[N/A] MUST: Header files must be in a -devel package.

[N/A] MUST: Static libraries must be in a -static package.

[N/A] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.

[N/A] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}

[x] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

[x] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.

[x] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.

[x] MUST: All filenames in rpm packages must be valid UTF-8.



[x] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [25]

[x] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [26]

[x] SHOULD: The reviewer should test that the package builds in mock. [27]

[x] SHOULD: The package should compile and build into binary rpms on all supported architectures. [28]

[x] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
did some simple run.
[x] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [29]

[N/A] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [21]

[N/A] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [30]

[N/A] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [31]

[x] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[32]


$ rpmlint gcal.spec gcal-3.6-2.fc15.src.rpm /home/rpmbuild/RPMS/i686/gcal-3.6-2.el6.i686.rpm
gcal.spec: W: no-cleaning-of-buildroot %clean
gcal.spec: W: no-buildroot-tag
gcal.spec: W: no-%clean-section
gcal.spec: W: invalid-url Source1: gcal-man-v3.6.tar.gz
gcal.spec: W: invalid-url Source0: ftp://ftp.gnu.org/gnu/gcal/gcal-3.6.tar.xz <urlopen error ftp error: timed out>
gcal.src: W: spelling-error %description -l en_US proleptic -> narcoleptic, proletarian, proletariat
gcal.src: W: non-standard-group Unspecified
gcal.src: W: no-cleaning-of-buildroot %clean
gcal.src: W: no-buildroot-tag
gcal.src: W: no-%clean-section
gcal.src: W: invalid-url Source1: gcal-man-v3.6.tar.gz
gcal.src: W: invalid-url Source0: ftp://ftp.gnu.org/gnu/gcal/gcal-3.6.tar.xz <urlopen error ftp error: timed out>
gcal.i686: W: spelling-error %description -l en_US proleptic -> narcoleptic, proletarian, proletariat
gcal.i686: W: non-standard-group Unspecified
2 packages and 1 specfiles checked; 0 errors, 14 warnings.

Summanry:
1. its better to add a group in the spec file.
2. use optflags when building.
All other looks fine.

Comment 4 Daiki Ueno 2011-05-17 08:27:32 UTC
(In reply to comment #3)

> 1. its better to add a group in the spec file.
> 2. use optflags when building.

Thanks for the review.  Updated:

Spec URL: http://ueno.fedorapeople.org/gcal/gcal.spec
SRPM URL: http://ueno.fedorapeople.org/gcal/gcal-3.6-3.fc15.src.rpm

Comment 5 Hushan Jia 2011-05-17 08:34:35 UTC
looks good, package APPROVED.

Comment 6 Daiki Ueno 2011-05-17 08:42:26 UTC
New Package SCM Request
=======================
Package Name: gcal
Short Description: GNU Gregorian calendar program
Owners: ueno
Branches: f15 f14 f13
InitialCC:

Comment 7 Jason Tibbitts 2011-05-18 22:23:16 UTC
Git done (by process-git-requests).

Comment 8 Fedora Update System 2011-05-19 01:39:25 UTC
gcal-3.6-3.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/gcal-3.6-3.fc14

Comment 9 Fedora Update System 2011-05-19 01:39:33 UTC
gcal-3.6-3.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/gcal-3.6-3.fc13

Comment 10 Fedora Update System 2011-05-19 01:39:42 UTC
gcal-3.6-3.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/gcal-3.6-3.fc15

Comment 11 Daiki Ueno 2011-05-19 01:42:55 UTC
Thanks Theodore, Hushan, and Jason.  Closing.

Comment 12 Fedora Update System 2011-05-27 20:19:38 UTC
gcal-3.6-3.fc15 has been pushed to the Fedora 15 stable repository.

Comment 13 Fedora Update System 2011-05-27 20:21:17 UTC
gcal-3.6-3.fc13 has been pushed to the Fedora 13 stable repository.

Comment 14 Fedora Update System 2011-05-27 20:24:16 UTC
gcal-3.6-3.fc14 has been pushed to the Fedora 14 stable repository.


Note You need to log in before you can comment on or make changes to this bug.